/**********/
#define     TEMP_MEM_0        dword ptr [esp+0x00]
#define     TEMP_MEM_1        dword ptr [esp+0x04]
#define     TEMP_MEM_2        dword ptr [esp+0x08]
#define     TEMP_MEM_3        dword ptr [esp+0x0C]
#define     KEY_ADDRESS     dword ptr [esp+0x10]
#define     DATA_ADDRESS    dword ptr [esp+0x14]
#define     TEMP_EBP        dword ptr [esp+0x18]
/**********/

/************************************************************/
/************************************************************/
/***
    A = S0[E0] ^ S1[F0] ^ S2[G0] ^ S3[H0] ^ K0; \
    B = S1[E1] ^ S2[F1] ^ S3[G1] ^ S0[H1] ^ K1; \
    C = S2[E2] ^ S3[F2] ^ S0[G2] ^ S1[H2] ^ K2; \
    D = S3[E3] ^ S0[F3] ^ S1[G3] ^ S2[H3] ^ K3; \
***/

#define ASM_CryptonRound(K0,K1,K2,K3,S0,S1,S2,S3) {                \
        _asm    mov     TEMP_MEM_1, esi             /*    0S    */    \
        _asm    mov     bl, al                        /*    1A    */    \
        _asm    mov     dl, ah                        /*    1B    */    \
        _asm    mov     TEMP_MEM_2, ecx             /*    0S    */    \
        _asm    shr     eax, 0x10                    /*    1    */    \
        _asm    mov     ebp, dword ptr [S0+4*ebx]    /*    1A    */    \
\
        _asm    mov     TEMP_MEM_3, edi                /*    0S    */    \
        _asm    mov     bl, al                        /*    1C    */    \
        _asm    mov     esi, dword ptr [S1+4*edx]    /*    1B    */    \
        _asm    mov     dl, ah                        /*    1D    */    \
        _asm    mov     eax, TEMP_MEM_1                /*    2    */    \
        _asm    mov     ecx, dword ptr [S2+4*ebx]    /*    1C    */    \
\
        _asm    mov     edi, dword ptr [S3+4*edx]    /*    1D    */    \
        _asm    mov     bl, al                        /*    2A    */    \
        _asm    mov     dl, ah                        /*    2B    */    \
        _asm    shr     eax, 0x10                    /*    2    */    \
        _asm    xor     ebp, dword ptr [S1+4*ebx]    /*    2A    */    \
        _asm    mov     bl, al                        /*    2C    */    \
\
        _asm    xor     esi, dword ptr [S2+4*edx]    /*    2B    */    \
        _asm    mov     dl, ah                        /*    2D    */    \
        _asm    mov     eax, TEMP_MEM_2                /*    3    */    \
        _asm    xor     ecx, dword ptr [S3+4*ebx]    /*    2C    */    \
        _asm    mov     bl, al                        /*    3A    */    \
        _asm    xor     edi, dword ptr [S0+4*edx]    /*    2D    */    \
\
        _asm    mov     dl, ah                        /*    3B    */    \
        _asm    shr     eax, 0x10                    /*    3    */    \
        _asm    xor     ebp, dword ptr [S2+4*ebx]    /*    3A    */    \
        _asm    mov     bl, al                        /*    3C    */    \
        _asm    xor     esi, dword ptr [S3+4*edx]    /*    3B    */    \
        _asm    mov     dl, ah                        /*    3D    */    \
\
        _asm    mov     eax, TEMP_MEM_3                /*    4    */    \
        _asm    xor     ecx, dword ptr [S0+4*ebx]    /*    3C    */    \
        _asm    mov     bl, al                        /*    4A    */    \
        _asm    xor     edi, dword ptr [S1+4*edx]    /*    3D    */    \
        _asm    mov     dl, ah                        /*    4B    */    \
        _asm    shr     eax, 0x10                    /*    4    */    \
\
        _asm    xor     ebp, dword ptr [S3+4*ebx]    /*    4A    */    \
        _asm    mov     bl, al                        /*    4D    */    \
        _asm    xor     esi, dword ptr [S0+4*edx]    /*    4B    */    \
        _asm    mov     dl, ah                        /*    4C    */    \
        _asm    mov     eax, ebp                    /*    K.    */    \
        _asm    mov     ebp, KEY_ADDRESS            /*    K.    */    \
\
        _asm    xor     ecx, dword ptr [S1+4*ebx]    /*    4D    */    \
        _asm    xor     edi, dword ptr [S2+4*edx]    /*    4C    */    \
        _asm    xor     eax, dword ptr [ebp+K0]     /*    K0    */    \
        _asm    xor     esi, dword ptr [ebp+K1]     /*    K1    */    \
        _asm    xor     ecx, dword ptr [ebp+K2]     /*    K2    */    \
        _asm    xor     edi, dword ptr [ebp+K3]     /*    k3    */    \
    }


/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/
/***
    E = ((DWORD *)pbData)[0] ^ K[0];
    F = ((DWORD *)pbData)[1] ^ K[1];
    G = ((DWORD *)pbData)[2] ^ K[2];
    H = ((DWORD *)pbData)[3] ^ K[3];
***/

#define ASM_Init(K0,K1,K2,K3) {                                 \
        _asm    sub     esp, 0x1C                    /*1     */    \
        _asm    mov     ebx, dword ptr [pbData]        /*2     */    \
        _asm    mov     edx, dword ptr [pdwRoundKey]/*3     */    \
        _asm    mov     TEMP_EBP, ebp                /*4     */    \
        _asm    mov     eax, dword ptr [ebx+0x00]    /*5     */    \
        _asm    mov     esi, dword ptr [ebx+0x04]    /*6     */    \
\
        _asm    mov     DATA_ADDRESS, ebx            /*1     */    \
        _asm    mov     ecx, dword ptr [ebx+0x08]    /*2     */    \
        _asm    mov     edi, dword ptr [ebx+0x0C]    /*3     */    \
        _asm    mov     KEY_ADDRESS, edx            /*4     */    \
        _asm    mov     ebx, dword ptr [edx+0x00]    /*5     */    \
        _asm    mov     ebp, dword ptr [edx+0x04]    /*6     */    \
\
        _asm    xor     ecx, dword ptr [edx+0x08]    /*1     */    \
        _asm    xor     eax, ebx                    /*2     */    \
        _asm    xor     esi, ebp                    /*3     */    \
        _asm    xor     edi, dword ptr [edx+0x0C]    /*4     */    \
        _asm    xor     ebx, ebx                    /*5        */    \
        _asm    xor     edx, edx                    /*6        */    \
    }

/************************************************************/
/************************************************************/


/************************************************************/
/************************************************************/
/***
    pb[ 0] = S2[GetByte0(A)] ^ GetByte0((K)[0]);    \
    pb[ 1] = S3[GetByte0(B)] ^ GetByte1((K)[0]);    \
    pb[ 4] = S3[GetByte1(A)] ^ GetByte0((K)[1]);    \
    pb[ 5] = S0[GetByte1(B)] ^ GetByte1((K)[1]);    \
    pb[ 8] = S0[GetByte2(A)] ^ GetByte0((K)[2]);    \
    pb[ 9] = S1[GetByte2(B)] ^ GetByte1((K)[2]);    \
    pb[12] = S1[GetByte3(A)] ^ GetByte0((K)[3]);    \
    pb[13] = S2[GetByte3(B)] ^ GetByte1((K)[3]);    \
    pb[ 2] = S0[GetByte0(C)] ^ GetByte2((K)[0]);    \
    pb[ 3] = S1[GetByte0(D)] ^ GetByte3((K)[0]);    \
    pb[ 6] = S1[GetByte1(C)] ^ GetByte2((K)[1]);    \
    pb[ 7] = S2[GetByte1(D)] ^ GetByte3((K)[1]);    \
    pb[10] = S2[GetByte2(C)] ^ GetByte2((K)[2]);    \
    pb[11] = S3[GetByte2(D)] ^ GetByte3((K)[2]);    \
    pb[14] = S3[GetByte3(C)] ^ GetByte2((K)[3]);    \
    pb[15] = S0[GetByte3(D)] ^ GetByte3((K)[3]);    \
***/

#define ASM_Final(K0,K1,K2,K3,S0,S1,S2,S3) {                    \
        _asm    mov        dword ptr [esp+0x08], ecx    /*        */    \
        _asm    xor        ebx, ebx                    /*        */    \
        _asm    xor        edx, edx                    /*        */    \
        _asm    mov        bl, al                        /*        */    \
        _asm    mov        dl, ah                        /*        */    \
        _asm    mov        ebp, DATA_ADDRESS            /*        */    \
\
        _asm    shr        eax, 0x10                    /*        */    \
        _asm    mov        cl, byte ptr [S2+ebx]        /*        */    \
        _asm    mov        bl, al                        /*        */    \
        _asm    mov        ch, byte ptr [S3+edx]        /*        */    \
        _asm    mov        dl, ah                        /*        */    \
        _asm    mov        byte ptr [ebp+0x00], cl        /*        */    \
\
        _asm    mov        eax, esi                    /*        */    \
        _asm    mov        byte ptr [ebp+0x04], ch        /*        */    \
        _asm    mov        cl, byte ptr [S0+ebx]        /*        */    \
        _asm    mov        bl, al                        /*        */    \
        _asm    mov        ch, byte ptr [S1+edx]        /*        */    \
        _asm    mov        dl, ah                        /*        */    \
\
        _asm    shr        eax, 0x10                    /*        */    \
        _asm    mov        byte ptr [ebp+0x08], cl        /*        */    \
        _asm    mov        byte ptr [ebp+0x0C], ch        /*        */    \
        _asm    mov        cl, byte ptr [S3+ebx]        /*        */    \
        _asm    mov        bl, al                        /*        */    \
        _asm    mov        ch, byte ptr [S0+edx]        /*        */    \
\
        _asm    mov        dl, ah                        /*        */    \
        _asm    mov        byte ptr [ebp+0x01], cl        /*        */    \
        _asm    mov        eax, dword ptr [esp+0x08]    /*        */    \
        _asm    mov        byte ptr [ebp+0x05], ch        /*        */    \
        _asm    mov        cl, byte ptr [S1+ebx]        /*        */    \
        _asm    mov        bl, al                        /*        */    \
\
        _asm    mov        ch, byte ptr [S2+edx]        /*        */    \
        _asm    mov        dl, ah                        /*        */    \
        _asm    mov        byte ptr [ebp+0x09], cl        /*        */    \
        _asm    mov        byte ptr [ebp+0x0D], ch        /*        */    \
        _asm    shr        eax, 0x10                    /*        */    \
        _asm    mov        cl, byte ptr [S0+ebx]        /*        */    \
\
        _asm    mov        bl, al                        /*        */    \
        _asm    mov        ch, byte ptr [S1+edx]        /*        */    \
        _asm    mov        dl, ah                        /*        */    \
        _asm    mov        byte ptr [ebp+0x02], cl        /*        */    \
        _asm    mov        eax, edi                    /*        */    \
        _asm    mov        byte ptr [ebp+0x06], ch        /*        */    \
\
        _asm    mov        cl, byte ptr [S2+ebx]        /*        */    \
        _asm    mov        bl, al                        /*        */    \
        _asm    mov        ch, byte ptr [S3+edx]        /*        */    \
        _asm    mov        dl, ah                        /*        */    \
        _asm    shr        eax, 0x10                    /*        */    \
        _asm    mov        byte ptr [ebp+0x0A], cl        /*        */    \
\
        _asm    mov        byte ptr [ebp+0x0E], ch        /*        */    \
        _asm    mov        cl, byte ptr [S1+ebx]        /*        */    \
        _asm    mov        bl, al                        /*        */    \
        _asm    mov        ch, byte ptr [S2+edx]        /*        */    \
        _asm    mov        dl, ah                        /*        */    \
        _asm    mov        byte ptr [ebp+0x03], cl        /*        */    \
\
        _asm    mov        byte ptr [ebp+0x07], ch        /*        */    \
        _asm    mov        cl, byte ptr [S3+ebx]        /*        */    \
        _asm    mov     esi, KEY_ADDRESS            /*        */    \
        _asm    mov        ch, byte ptr [S0+edx]        /*        */    \
        _asm    mov        byte ptr [ebp+0x0B], cl        /*        */    \
        _asm    mov        byte ptr [ebp+0x0F], ch        /*        */    \
\
        _asm    mov        eax, dword ptr [ebp+0x00]    /*        */    \
        _asm    mov        ebx, dword ptr [ebp+0x04]    /*        */    \
        _asm    mov        ecx, dword ptr [esi+K2]        /*        */    \
        _asm    mov        edi, dword ptr [esi+K3]        /*        */    \
        _asm    xor        eax, dword ptr [esi+K0]        /*        */    \
        _asm    xor        ebx, dword ptr [esi+K1]        /*        */    \
\
        _asm    xor        ecx, dword ptr [ebp+0x08]    /*        */    \
        _asm    xor        edi, dword ptr [ebp+0x0C]    /*        */    \
        _asm    mov        dword ptr [ebp+0x00], eax    /*        */    \
        _asm    mov        dword ptr [ebp+0x04], ebx    /*        */    \
        _asm    mov        dword ptr [ebp+0x08], ecx    /*        */    \
        _asm    mov        dword ptr [ebp+0x0C], edi    /*        */    \
\
        _asm    mov     ebp, TEMP_EBP                /*3     */    \
        _asm    add     esp, 0x1C                    /*2     */    \
    }

/************************************************************/
/************************************************************/




/************************************************************/
/************************************************************/
/************************************************************/
/* Encrypt one block of plaintext: internal use only */
void CryptonEncrypt(pbData, pdwRoundKey)
BYTE *pbData;
DWORD *pdwRoundKey;
{
    ASM_Init(0x00, 0x04, 0x08, 0x0C);
    ASM_CryptonRound(0x10, 0x14, 0x18, 0x1C, SS0, SS1, SS2, SS3);
    ASM_CryptonRound(0x20, 0x24, 0x28, 0x2C, SS2, SS3, SS0, SS1);
    ASM_CryptonRound(0x30, 0x34, 0x38, 0x3C, SS0, SS1, SS2, SS3);
    ASM_CryptonRound(0x40, 0x44, 0x48, 0x4C, SS2, SS3, SS0, SS1);
    ASM_CryptonRound(0x50, 0x54, 0x58, 0x5C, SS0, SS1, SS2, SS3);
    ASM_CryptonRound(0x60, 0x64, 0x68, 0x6C, SS2, SS3, SS0, SS1);
    ASM_CryptonRound(0x70, 0x74, 0x78, 0x7C, SS0, SS1, SS2, SS3);
    ASM_CryptonRound(0x80, 0x84, 0x88, 0x8C, SS2, SS3, SS0, SS1);
    ASM_CryptonRound(0x90, 0x94, 0x98, 0x9C, SS0, SS1, SS2, SS3);
    ASM_CryptonRound(0xA0, 0xA4, 0xA8, 0xAC, SS2, SS3, SS0, SS1);
    ASM_CryptonRound(0xB0, 0xB4, 0xB8, 0xBC, SS0, SS1, SS2, SS3);
    ASM_Final(0xC0, 0xC4, 0xC8, 0xCC, S0, S1, S2, S3);
}

/************************************************************/
/************************************************************/
/************************************************************/
#undef        TEMP_MEM_0
#undef        TEMP_MEM_1
#undef        TEMP_MEM_2
#undef        TEMP_MEM_3
#undef        KEY_ADDRESS
#undef        DATA_ADDRESS
#undef        TEMP_EBP

#undef        ASM_CryptonRound
#undef        ASM_Init
#undef        ASM_Final
/************************************************************/
/************************************************************/
/************************************************************/
