#ifndef __RIJNDAEL_ALG_H
#define __RIJNDAEL_ALG_H

#define MAXBC				(256/32)
#define MAXKC				(256/32)
#define MAXROUNDS			14

typedef unsigned char		word8;	
typedef unsigned short		word16;	
typedef unsigned long		word32;


int rijndaelKeySched (word8 k[MAXKC][4], int keyBits, int blockBits, 
		word8 rk[MAXROUNDS+1][MAXBC][4]);
int rijndaelKeyEnctoDec (int keyBits, int blockBits,
      word8 W[MAXROUNDS+1][MAXBC][4]);
int rijndaelKeyDectoEnc (int keyBits, int blockBits,
      word8 W[MAXROUNDS+1][MAXBC][4]);
int rijndaelEncrypt (word8 a[MAXBC][4], int keyBits, int blockBits, 
		word8 rk[MAXROUNDS+1][MAXBC][4]);
int rijndaelEncryptRound (word8 a[MAXBC][4], int keyBits, int blockBits, 
		word8 rk[MAXROUNDS+1][MAXBC][4], int rounds);
int rijndaelDecrypt (word8 a[MAXBC][4], int keyBits, int blockBits, 
		word8 rk[MAXROUNDS+1][MAXBC][4]);
int rijndaelDecryptRound (word8 a[MAXBC][4], int keyBits, int blockBits, 
		word8 rk[MAXROUNDS+1][MAXBC][4], int rounds);

#endif /* __RIJNDAEL_ALG_H */
